SystemOrganization addCategory: #LoadOrderTests!

!WriteStream methodsFor: '*loadordertests' stamp: 'jgf 2/6/2009 12:01'!
show: aString

	^self nextPutAll: aString.
	! !

Object subclass: #SeasideLoadOrderTests
	instanceVariableNames: 'userName password seaside29 komHttpServer baseTests baseUndeclared'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LoadOrderTests'!

!SeasideLoadOrderTests commentStamp: 'jgf 2/6/2009 12:08' prior: 0!
SeasideLoadOrderTests provides a single class that loads the packages described on the LoadOrder Wiki (http://code.google.com/p/seaside/wiki/LoadOrder), and shows the errors and undefined along the way.!

!SeasideLoadOrderTests class methodsFor: 'initialization' stamp: 'jgf 2/6/2009 11:20'!
initialize

	(UIManager default confirm: 'Load Seaside 2.9?') ifTrue: [
		self new doLoad.
	].
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/6/2009 09:23'!
adminToolsPackages

	^OrderedCollection new
		add: seaside29 -> 'Seaside-OmniBrowserTools-lr.14.mcz';
		add: seaside29 -> 'Seaside-Squeak-OmniBrowserTools-jgf.1.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/6/2009 12:43'!
basicPackages

	^OrderedCollection new
		"Platform"
		add: (Array 
			with: seaside29 -> 'Seaside-Platform-jf.47.mcz'
			with: seaside29 -> 'Seaside-Squeak-Platform-jf.52.mcz'
			with: seaside29 -> 'Seaside-Tests-Platform-jf.56.mcz'
			with: seaside29 -> 'Seaside-Tests-Squeak-Platform-jf.15.mcz');
		"Core"
		add: (Array 
			with: seaside29 -> 'Seaside-Core-jf.454.mcz'
			with: seaside29 -> 'Seaside-Tests-Core-jgf.91.mcz'
			with: seaside29 -> 'Seaside-Squeak-Core-jgf.75.mcz'
			with: seaside29 -> 'Seaside-Tests-Squeak-Core-jgf.12.mcz');
		"Canvas"
		add: (Array 
			with: seaside29 -> 'Seaside-Canvas-jf.44.mcz'
			with: seaside29 -> 'Seaside-Tests-Canvas-lr.21.mcz');
		"Continuation"
		add: (Array 
			with: seaside29 -> 'Seaside-Squeak-Continuation-jf.18.mcz'
			with: seaside29 -> 'Seaside-Tests-Squeak-Continuation-lr.5.mcz');
		"Session"
		add: (Array 
			with: seaside29 -> 'Seaside-Session-jf.98.mcz'
			with: seaside29 -> 'Seaside-Tests-Session-lr.21.mcz');
		"Component"
		add: (Array 
			with: seaside29 -> 'Seaside-Component-lr.47.mcz'
			with: seaside29 -> 'Seaside-Tests-Component-lr.20.mcz');
		"RenderLoop"
		add: (Array 
			with: seaside29 -> 'Seaside-RenderLoop-jf.52.mcz'
			with: seaside29 -> 'Seaside-Tests-RenderLoop-jf.7.mcz');
		"Environment"
		add: (Array 
			with: seaside29 -> 'Seaside-Environment-jf.46.mcz'
			with: seaside29 -> 'Seaside-Tests-Environment-jf.11.mcz');
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/6/2009 10:32'!
comanchePackages

	^OrderedCollection new
		add: komHttpServer	-> 'DynamicBindings-gc.7.mcz';
		add: komHttpServer	-> 'KomServices-gc.19.mcz';
		add: komHttpServer	-> 'KomHttpServer-rjl.43.mcz';
		add: seaside29		-> 'Seaside-Adaptors-Comanche-lr.28.mcz';
		add: seaside29		-> 'Seaside-Tests-Adaptors-Comanche-lr.7.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'utility' stamp: 'jgf 2/6/2009 09:08'!
condenceChanges
"
	SeasideLoadOrderTests new condenseChanges.
"
	Smalltalk condenseChanges.
	! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 12:11'!
doLoad

	self groups do: [:aList | 
		self 
			loadPackages: aList;
			doTests;
			yourself.
	].
! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 10:06'!
doTests

	| suite result |
	suite := TestCase suite.
	baseTests do: [:oldTest | 
		| duplicate |
		duplicate := suite tests detect: [:newTest | newTest class == oldTest class and: [newTest selector == oldTest selector]].
		suite tests remove: duplicate.
	].
	result := suite run.
	Transcript cr; tab; show: result printString.
	result defects do: [:each | 
		Transcript cr; tab; tab; show: each printString.
	].
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/6/2009 09:30'!
emailPackages

	^OrderedCollection new
		add: seaside29 -> 'Seaside-Email-lr.8.mcz';
		add: seaside29 -> 'Seaside-Tests-Email-pmm.5.mcz';
		add: seaside29 -> 'Seaside-Squeak-Email-pmm.6.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/6/2009 10:10'!
groups

	^OrderedCollection new
		addAll: self basicPackages;
		addAll: self traditionalPackages;
		add: self adminToolsPackages;
		add: self rssPackages;
		add: self javascriptPackages;
		add: self scriptaculousPackages;
		add: self htmlPackages;
		add: self internetExplorerPackages;
		add: self emailPackages;
		add: self comanchePackages;
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/6/2009 09:29'!
htmlPackages

	^OrderedCollection new
		add: seaside29 -> 'Seaside-HTML5-lr.5.mcz';
		add: seaside29 -> 'Seaside-Tests-HTML5-lr.10.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'initialize-release' stamp: 'jgf 2/6/2009 11:19'!
initialize

	super initialize.
	userName := UIManager default
		request: 'SqueakSource User Name (empty is fine)?'
		initialAnswer: ''.
	password := UIManager default
		request: 'SqueakSource Password (empty is fine)?'
		initialAnswer: ''.
	seaside29 := self seaside29.
	komHttpServer := self komHttpServer.
	baseTests := TestCase suite tests.
	baseUndeclared := Undeclared keys.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/6/2009 09:29'!
internetExplorerPackages

	^OrderedCollection new
		add: seaside29 -> 'Seaside-InternetExplorer-lr.4.mcz';
		add: seaside29 -> 'Seaside-Tests-InternetExplorer-lr.6.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/6/2009 09:26'!
javascriptPackages

	^OrderedCollection new
		add: seaside29 -> 'Javascript-Core-lr.39.mcz';
		add: seaside29 -> 'Javascript-Squeak-Core-lr.5.mcz';
		add: seaside29 -> 'Javascript-Tests-Core-lr.34.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'repositories' stamp: 'jgf 2/6/2009 09:15'!
komHttpServer

	^MCHttpRepository
		location: 'http://www.squeaksource.com/KomHttpServer'
		user: userName
		password: password.
! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 12:11'!
loadPackage: aString from: aRepository

	| version repositoryGroup transcript stream |
	version := aRepository loadVersionFromFileNamed: aString.
	transcript := Transcript.
	stream := WriteStream on: String new.
	[
		Transcript := stream.
		version load.
	] ensure: [
		Transcript := transcript.
	].
	self reportToTranscript: stream contents.
	repositoryGroup := version workingCopy repositoryGroup.
	repositoryGroup addRepository: aRepository.
	Transcript cr; show: 'Loaded ' , aString.
	self showUndeclared.
	! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 11:23'!
loadPackages: aList

	Transcript cr.
	aList do: [:assoc |
		self
			loadPackage: assoc value 
			from: assoc key.
	].
! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 11:39'!
reportToTranscript: aString

	| list |
	list := aString subStrings: (Array with: $().
	list := list collect: [:each | each withBlanksTrimmed].
	list := list reject: [:each | each isEmpty].
	list := list reject: [:each | 
		16 < each size and: [ (each copyFrom: each size - 14 to: each size) = ' is Undeclared)'].
	].
	list isEmpty ifTrue: [^self].
	Transcript nextPutAll: aString.
	! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/6/2009 09:25'!
rssPackages

	^OrderedCollection new
		add: seaside29 -> 'RSS-Core-lr.42.mcz';
		add: seaside29 -> 'RSS-Tests-Core-jgf.16.mcz';
		add: seaside29 -> 'RSS-Examples-jf.15.mcz';
		add: seaside29 -> 'RSS-Squeak-Examples-jf.7.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/6/2009 09:28'!
scriptaculousPackages

	^OrderedCollection new
		add: seaside29 -> 'Scriptaculous-Core-lr.74.mcz';
		add: seaside29 -> 'Scriptaculous-Tests-Core-lr.23.mcz';
		add: seaside29 -> 'Scriptaculous-Components-jf.75.mcz';
		add: seaside29 -> 'Scriptaculous-Tests-Components-jf.18.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'repositories' stamp: 'jgf 2/6/2009 09:09'!
seaside29

	^MCHttpRepository
		location: 'http://www.squeaksource.com/Seaside29'
		user: ''
		password: ''.
! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 10:37'!
showUndeclared

	| newUndeclared |
	newUndeclared := Undeclared keys.
	baseUndeclared do: [:each | newUndeclared remove: each].
	newUndeclared isEmpty ifTrue: [^self].
	Transcript cr; tab; show: 'Undeclared: ' , newUndeclared asSortedCollection asArray printString.
	! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/6/2009 10:05'!
traditionalPackages

	^OrderedCollection new
		"Functional Tests"	
		add: (Array 
			with: seaside29 -> 'Seaside-Tests-Functional-lr.53.mcz'
			with: seaside29 -> 'Seaside-Tests-Squeak-Functional-jf.9.mcz');
		"Continuation are temporarily in Basic"

		"Flow"
		add: (Array 
			with: seaside29 -> 'Seaside-Flow-jf.5.mcz'
			with: seaside29 -> 'Seaside-Squeak-Flow-lr.5.mcz'
			with: seaside29 -> 'Seaside-Tests-Flow-jf.5.mcz');
		"WebTools"
		add: (Array 
			with: seaside29 -> 'Seaside-WebTools-jf.13.mcz'
			with: seaside29 -> 'Seaside-Squeak-WebTools-lr.9.mcz'
			with: seaside29 -> 'Seaside-Tests-WebTools-lr.4.mcz');
		"Development"
		add: (Array 
			with: seaside29 -> 'Seaside-Development-lr.78.mcz'
			with: seaside29 -> 'Seaside-Squeak-Development-lr.72.mcz'
			with: seaside29 -> 'Seaside-Tests-Development-jf.25.mcz'
			with: seaside29 -> 'Seaside-Tests-Squeak-Development-jf.9.mcz');
		"Examples"
		add: (Array 
			with: seaside29 -> 'Seaside-Examples-jf.10.mcz');
		yourself.! !
SeasideLoadOrderTests initialize!
